
# <b>Liste</b> regelt die Zugriffe auf die Datei "lists" der Tabellenwerte sowie
# die Aktionen und sonstigen Informationen, die im Zusammenhang damit stehen 
#
# auftretende Fehler werden dabei idR. als Programmierfehler betrachtet: keine Ausgabe ber @notice

class Liste

  attr_reader :liste, :select, :key, :desc, :prv

  # <b>initialize</b> liest die angeforderten Daten der Datei ein und speichert sie
  
  def initialize(*list)
    @@data      = {}    if !defined?(@@data)  
    ok          = false
    if list[0].class == String
      liste = list[0]
      value = list[1]     if list[1]
      ok    = list[2]     if list[2]
    else
      liste = list[0][0]
      value = list[0][1]  if list[0][1]
      ok    = list[0][2]  if list[0][2]
    end
    
    if @@data.key?(liste)
      @liste              = @@data.fetch(liste)[0]
      @prv                = @@data.fetch(liste)[1]     
    else        
      liste               = list.length == 0 ?  "Liste" : liste
      @liste              = List.find_all_by_liste(liste, :order => 'listKey')
      @prv                = 0    
      @@data[liste]       = [@liste, @prv]
    end
    
    @select, @key, @desc  = 0, '', ''
    pos(value)          if value
    @prv = @@data[liste][1]  = @select if select  > 0 && ok 
  end  
  
  ######################################################################################################   
 
  private
  
  def pos(value) # zu selektierender Tabellenwert
    @liste.each do |liste|
        @select, @key, @desc    = liste.id, liste.listKey, liste.beschreibung
        break if liste.id       == value.to_i  &&   value.to_i > 0
        break if liste.listKey  == value
        @select, @key, @desc = 0, '', ''      # fr den Fall, dass kein Wert bereinstimmt
        end
  end  

end